#!/usr/bin/env node
import { I as r, S as d } from "./index-a1ee6691.js";
import { log as o, _get as j, initHandlerCommon as b, getConfigFileCommonOptions as D, _set as w, readConfigFile as _, createSubcommand as N, createMainCommand as k } from "@done-coding/cli-utils";
import $ from "node:path";
import m from "node:fs";
const M = ({
  sourceJson: e,
  targetKey: n,
  keyConfig: t
}) => {
  let s;
  typeof t == "string" ? s = {
    type: r.FIXED,
    value: t
  } : s = t;
  const { type: a = r.READ } = s;
  switch (a) {
    case r.REG: {
      const { sourceKey: c, pattern: f, replaceValue: p, flags: g } = s, y = new RegExp(f, g ?? void 0), i = j(e, c);
      return typeof i == "string" ? i.replace(y, p) : (o.warn(
        `${i}不是字符串类型，无法使用正则表达式进行替换，此处将直接返回原值`
      ), i);
    }
    case r.FIXED: {
      const { value: c } = s;
      return c;
    }
    case r.READ: {
      const { sourceKey: c = n } = s;
      return j(e, c);
    }
    default: {
      o.warn(`未知的配置类型${a}`);
      return;
    }
  }
}, h = {
  name: "@done-coding/cli-inject",
  version: "0.5.11-alpha.0",
  description: "信息(JSON)注入命令行工具",
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "inject"
  }
}, {
  cliConfig: { namespaceDir: x, moduleName: G }
} = h, L = `./${x}/${G}`, R = `${L}.json`, F = {
  sourceFilePath: "./package.json",
  keyConfigMap: {
    name: {
      type: r.READ
    },
    version: {
      type: r.READ
    },
    description: {
      type: r.READ
    }
  },
  injectFilePath: "./src/injectInfo.json"
}, J = () => D({
  configPathDefault: R
}), O = async (e) => b(F, e, {
  onFileGenerated: () => {
    o.info("文件生成成功");
  }
}), U = {
  command: d.INIT,
  describe: "初始化配置文件",
  options: J(),
  handler: O
}, V = () => ({
  ...D({
    configPathDefault: R
  })
}), H = async ({
  rootDir: e = process.cwd(),
  config: n = F,
  keyConfigMap: t = {}
} = {}) => {
  const {
    sourceFilePath: s,
    keyConfigMap: a,
    injectFilePath: c
  } = n, f = {
    ...a,
    ...t
  };
  if (!s.endsWith(".json"))
    return o.error("源文件必须是json"), process.exit(1);
  if (!c.endsWith(".json"))
    return o.error("注入文件必须是json"), process.exit(1);
  const p = $.resolve(e, s), g = m.readFileSync(p, "utf-8"), y = JSON.parse(g), i = Object.entries(f).reduce(
    (u, [I, P]) => {
      const T = M({ sourceJson: y, targetKey: I, keyConfig: P });
      return w(u, I, T), u;
    },
    {}
  ), l = $.resolve(e, c), E = JSON.stringify(i, null, 2);
  if (m.existsSync(l)) {
    const u = m.readFileSync(l, "utf-8");
    if (E === u)
      return o.skip("注入文件已存在且内容相同，无需重复注入"), i;
    o.stage("文件内容变化,开始覆盖注入文件");
  } else
    o.stage("开始注入文件");
  m.writeFileSync(l, E), o.success(`文件注入成功: ${l}`), o.info(E);
}, C = async (e) => {
  const n = await _(e, () => (o.info("配置文件为空，使用默认配置"), F));
  if (!n)
    return o.error("配置文件为空"), process.exit(1);
  const { rootDir: t } = e;
  await H({ rootDir: t, config: n });
}, K = {
  command: d.GENERATE,
  describe: "生成文件",
  options: V(),
  handler: C
}, Y = async (e, n) => {
  switch (e) {
    case d.INIT:
      return O(n);
    case d.GENERATE:
      return C(n);
    default:
      return C(n);
  }
}, { version: W, description: X } = h, S = {
  describe: X,
  version: W,
  subcommands: [U, K].map(
    N
  ),
  demandCommandCount: 1
}, {
  cliConfig: { moduleName: A }
} = h, v = (e = !1) => {
  const n = e ? A : void 0, t = `$0${e ? ` ${A}` : ""} <command> [options]`;
  return { command: n, usage: t };
}, Z = async () => k({
  ...S,
  ...v()
}), ee = () => N({
  ...S,
  ...v(!0)
});
export {
  ee as a,
  U as b,
  Z as c,
  C as d,
  K as e,
  Y as f,
  H as g,
  O as h,
  S as i,
  M as k
};
